Dim As Single pi = 4 * Atn(1), differenceDeMarche, periode, phase, temps
Dim As Single theta, xCoord, yCoord, xCarre, xPrime, tPrime, diagonale, beta
Screen 19,24,3: page1 = 1: Gosub Initialisation
Do'            L'EFFET DOPPLER CALCUL  L'AIDE DES TRANSFORMATIONS DE LORENTZ.
  Swap page1, page2
  Screenset page1, page2
  Pcopy 2, page1
  image = image + 1                                       'espace: mesur en longueurs d'onde.
  temps = image / images                                  'temps:  mesur en priode d'onde.
  For x = 0 To largeur                                    'coordonne x du pixel.
    xCoord = (x - xCentre) / lambda                       'coordonne x en longueurs d'onde.
    xCarre = xCoord * xCoord                              'distance non transforme au carr.
    xPrecedent = xPixel

'------------------------ APPLIQUER LES TRANSFORMATIONS DE LORENTZ ---------------------------
'   Grce  l'angle thta, qui vaut: arc sin (v / c),
'   les transformations de Lorentz peuvent tre exprimes ainsi:
'   x' = x * Cos(theta) + t * Sin(theta)
'   t' = t * Cos(theta) - x * Sin(theta)
'   Pour retrouver les variables d'origine, il faut faire bien videmment:
'   x = (x' - t * Sin(theta)) / Cos(theta)
'   t = (t' + x * Sin(theta)) / Cos(theta)
'   Toutefois, il faut permuter les variables pour retrouver les quations de Lorentz:
'   x' = (x - t * Sin(theta)) / Cos(theta)
'   t' = (t + x * Sin(theta)) / Cos(theta)
'   Cela s'explique parce que Woldemar Voigt avait tent d'laborer en 1887 des quations
'   dans le but de corriger l'effet Doppler en les appliquant aux quations de Maxwell.
'   Sachant qu'elles indiquaient une contraction, Lorentz les a rcupres et amliores en
'   1895 dans le but d'expliquer pourquoi l'interfromtre de Michelson ne fonctionnait pas.
'   Mais c'est Henri Poincar qui a finalement donn les valeurs dfinitives en 1904.
'   Dans leur forme d'origine, les transformations de Lorentz ont donc pour effet de corriger
'   l'effet Doppler. C'est pourquoi le fait de permuter les variables a plutt pour 
'   consquence de provoquer  l'effet Doppler. En plus de la contraction, il se produit un
'   ralentissement de la frquence. Mais l'effet le plus spectaculaire, c'est l'apparition
'   d'heures locales, qui font en sorte en pratique que la priode des ondes volue le long
'   de l'axe du dplacement. Cela se traduit par une  onde de phase  qui est trs visible
'   dans le cas des ondes stationnaires  des vitesses faibles, par exemple: v / c = 0,1.

    xPrime = xCoord * Cos(theta) + temps * Sin(theta)     'distance x' en longueurs d'onde.
    xPixel = xPrime * lambda                              'nombre entier pour le pixel.
    xCoord = (xPixel / lambda - temps * Sin(theta)) / Cos(theta)'retrouver le chiffre exact.
    tPrime = temps * Cos(theta) - xCoord * Sin(theta)     'temps t' en priode d'onde.

    If xPixel + largeur / 2 > 800 Then image = 0          'image hors-cran: recycler.
    For y = 0 To hauteur / 2                              'coordonnee y du pixel, symtrie axiale.
      yCoord = (y - yCentre) / lambda                     'coordonne y en longueurs d'onde.
      diagonale = Sqr(xCarre + yCoord * yCoord)           'selon Pythagore, en longueurs d'onde.

'------------------------------ AFFICHER LES ONDES NORMALES ----------------------------------
      Select Case mode$
        Case "convergentes" : phase = 2 * pi * (-diagonale - temps)'en radians, temps absolu.
                              ton = 128 * (Sin(phase) + 1)
        Case "divergentes"  : phase = 2 * pi * (diagonale - temps)
                              ton = 128 * (Sin(phase) + 1)
        Case "stationnaires"
          If diagonale < .25 Then diagonale = .25         'noyau onde entire de l'lectron.
          phase = 2 * pi * (diagonale + temps)            'onde convergente.
          ton = 64 * (Sin(phase) + 1)
          phase = 2 * pi * (diagonale - temps)            'onde divergente.
          ton = ton + 64 * (Sin(phase) + 1)
      End Select
      If ton < 0 Then ton = 0 Else If ton > 255 Then ton = 255
      Pset(x, hauteur + y + 6), Rgb(ton,ton,ton)          'afficher l'onde normale.
      Pset(x, 2 * hauteur - y + 6), Rgb(ton,ton,ton)      'symtrie axiale.

'---------------------- AFFICHER LES ONDES TRANSFORMES SELON LORENTZ ------------------------
      If xPixel > xPrecedent Then                         'passer si le pixel est dj trait.
        diagonale = Sqr(xCoord * xCoord + yCoord * yCoord)'
        Select Case mode$
          Case "convergentes" : phase = 2 * pi * (-diagonale - tPrime)
                                ton = 128 * (Sin(phase) + 1)
          Case "divergentes"  : phase = 2 * pi * (diagonale - tPrime)
                                ton = 128 * (Sin(phase) + 1)
          Case "stationnaires"
            If diagonale < .25 Then diagonale = .25       'noyau onde entire de l'lectron.
            phase = 2 * pi * (diagonale + tPrime)         'onde convergente.
            ton = 64 * (Sin(phase) + 1)
            phase = 2 * pi * (diagonale - tPrime)         'onde divergente.
            ton = ton + 64 * (Sin(phase) + 1)
        End Select
        If ton < 0 Then ton = 0 Else If ton > 255 Then ton = 255
        Pset(xPixel + largeur / 2, y), Rgb(ton,ton,ton)   'afficher l'onde avec effet Doppler.
        Pset(xPixel + largeur / 2, hauteur - y), Rgb(ton,ton,ton)
      End If
    Next y
  Next x

  saisie$ = Inkey
  If Len(saisie$) = 2 And Right(saisie$, 1) = "k" Then End'  X  de la fentre.
  If Len(saisie$) = 2 Then saisie$ = Right(saisie$, 1) + "+" Else saisie$ = Ucase(saisie$)
  If Len(saisie$) Then
    Do: Loop While Len(inkey)                             'vider le tampon.
    capture = 0
    If Len(saisie$) = 2 Then saisie$ = right(saisie$, 1) + "+"
    Select Case saisie$
      Case "I": Gosub Initialisation
      Case "X+", CHR$(27): End
      Case "C": mode$ = "convergentes"
      Case "D": mode$ = "divergentes"
      Case "S": mode$ = "stationnaires"
      Case "M": Run "Ether00.exe"
      Case "K+":Run "Ether16.exe"                         'flche gauche.
      Case "M+":Run "Ether00.exe"                         'flche droite.  
      Case "1": vitesse$ = ".1"
      Case "2": vitesse$ = ".2"
      Case "3": vitesse$ = ".3"
      Case "4": vitesse$ = ".4"
      Case "5": vitesse$ = ".5"
      Case "6": vitesse$ = ".6"
      Case "7": vitesse$ = ".707"
      Case "8": vitesse$ = ".8"
      Case "9": vitesse$ = ".866"
      Case "0": vitesse$ =  "0"
      Case Else: Saisie$ = "nul"
    End Select
    If Saisie$ = "nul" Then Else Gosub MiseAJour
  End If

  Getmouse xSouris, ySouris, , clic                       'saisie Souris.
  ligne = .5 + ySouris / 16
  Select Case ligne
    Case Is > 34: If ligne > 37 Or xSouris < 304 Or xSouris > 496 Then ligne = 0
    Case Is > 29: ligne = 0
    Case Is > 14: If xSouris < 552 Then ligne = 0
    Case Else: ligne = 0
  End Select
  If ligne = 0 Then clic = 0
  If clic = 1 Then
    Select Case ligne
      Case 15: vitesse$ =  "0"
      Case 16: vitesse$ = ".1"
      Case 17: vitesse$ = ".2"
      Case 18: vitesse$ = ".3"
      Case 19: vitesse$ = ".4"
      Case 20: vitesse$ = ".5"
      Case 21: vitesse$ = ".6"
      Case 22: vitesse$ = ".707"
      Case 23: vitesse$ = ".8"
      Case 24: vitesse$ = ".866"
      Case 26: If mode$ <> "convergentes" Then mode$ = "convergentes" Else ligne = 0
      Case 27: If mode$ <> "divergentes" Then mode$ = "divergentes" Else ligne = 0
      Case 28: If mode$ <> "stationnaires" Then mode$ = "stationnaires" Else ligne = 0
      Case 29: Gosub CurseurLambda
      Case 35: Gosub Initialisation
      Case 36: End
      Case 37: If xSouris < 400 Then Run "Ether16.exe" Else Run "Ether00.exe"
      Case Else: ligne = 0
    End Select
    If ligne Then Gosub MiseAJour
  End If

  Color , turquoise: Locate ligne, 70
  Select Case ligne                                       'rehausser l'affichage.
    Case 15: If vitesse$ <> "0"    Then Print ligne15$
    Case 16: If vitesse$ <> ".1"   Then Print ligne16$
    Case 17: If vitesse$ <> ".2"   Then Print ligne17$
    Case 18: If vitesse$ <> ".3"   Then Print ligne18$
    Case 19: If vitesse$ <> ".4"   Then Print ligne19$
    Case 20: If vitesse$ <> ".5"   Then Print ligne20$
    Case 21: If vitesse$ <> ".6"   Then Print ligne21$
    Case 22: If vitesse$ <> ".707" Then Print ligne22$
    Case 23: If vitesse$ <> ".8"   Then Print ligne23$
    Case 24: If vitesse$ <> ".866" Then Print ligne24$
    Case 26: If mode$ <> "convergentes"  Then Print ligne26$
    Case 27: If mode$ <> "divergentes"   Then Print ligne27$
    Case 28: If mode$ <> "stationnaires" Then Print ligne28$
    Case 29: Print ligne29$
    Case 35: Locate, 39: Print ligne35$
    Case 36: Locate, 39: Print ligne36$
    Case 37: Locate, 39: Print ligne37$;
             If xSouris < 400 Then Gosub flecheGauche Else Gosub flecheDroite
  End Select
  Color noir, fond
Loop

CurseurLambda:'-------------- MODIFICATION DE LA LONGUEUR D'ONDE -----------------------------
lambdaPrec = lambda                                       'lambda: minimum 10, maximum 100.
Do
  Swap page1, page2
  Screenset page1, page2
  Cls
  curseur = 551 + 2 * lambda
  Line(570,447)-(752, 464), noir, b
  Line(curseur - 1,448)-(curseur + 1, 464), noir, bf
  Line(658 - lambda / 2,431)-(658 + lambda / 2, 447), noir, bf
  rayon = Int(longueurSource / 2)
  Locate 23, 45: Print "Agrandir la longueur d'onde quivaut  faire un zoom."
  Locate 25, 45: Print "Longueur d'onde (lambda):"; lambda; " pixels."
  If ySouris > 447 And ySouris < 465 Then 
    lambda = Int((xSouris - 550) / 2)
  Else lambda = lambdaPrec
  End If
  If lambda > 100 Then lambda = 100 Else If lambda < 10 Then lambda = 10
  Getmouse xSouris, ySouris, , clic
Loop While clic = 1
If lambdaPrec = lambda Then Else Gosub MiseAJour: calculFait = 0
Return
'------------------------------------- DESSIN DES FLCHES ------------------------------------
flecheGauche:
Line (xgg+6,yFleche-4)-(xgg+8,yFleche-4),noir
Line (xgg+4,yFleche-3)-(xgg+8,yFleche-3),noir
Line (xgg+2,yFleche-2)-(xgg+8,yFleche-2),noir
Line (xgg,yFleche-1)-(xgd,yFleche-1),noir
Line (xgg-2,yFleche)-(xgd,yFleche),noir
Line (xgg,yFleche+1)-(xgd,yFleche+1),noir
Line (xgg+2,yFleche+2)-(xgg+8,yFleche+2),noir
Line (xgg+4,yFleche+3)-(xgg+8,yFleche+3),noir
Line (xgg+6,yFleche+4)-(xgg+8,yFleche+4),noir
Return
flecheDroite:
Line (xdd-8,yFleche-4)-(xdd-6,yFleche-4),noir
Line (xdd-8,yFleche-3)-(xdd-4,yFleche-3),noir
Line (xdd-8,yFleche-2)-(xdd-2,yFleche-2),noir
Line (xdg,yFleche-1)-(xdd,yFleche-1),noir
Line (xdg,yFleche)-(xdd+2,yFleche),noir
Line (xdg,yFleche+1)-(xdd,yFleche+1),noir
Line (xdd-8,yFleche+2)-(xdd-2,yFleche+2),noir
Line (xdd-8,yFleche+3)-(xdd-4,yFleche+3),noir
Line (xdd-8,yFleche+4)-(xdd-6,yFleche+4),noir
Return

Initialisation:'------------------------ INITIALISATION --------------------------------------
fond = Rgb(225,225,225)
vert = Rgb(0,150,0)
bleu = Rgb(0,0,255)
rouge = Rgb(255,0,0)
blanc = Rgb(255,255,255)
turquoise = Rgb (230, 255, 255)
vitesse$ = ".866"                                         'vitesse$ normalise selon c = 1.
images = 24: lambda = 20
largeur = 540: hauteur = 200
xCentre = largeur / 2: yCentre = hauteur / 2
mode$ = "divergentes"
xgg = 400 - 50                                            'coordonnes des flches.
xgd = 400 - 20
xdg = 400 + 20
xdd = 400 + 50
yFleche = 584
Screenset 2
Color noir, fond: Cls
Locate 14, 74: Print "Bta    Thta  Contraction"
ligne15$ = " 0 - 0,0     0"      + chr(248) + "        0,0     ": Locate 15, 70: Print ligne15$
ligne16$ = " 1 - 0,1     5,739"  + chr(248) + "    0,995   ":     Locate 16, 70: Print ligne16$
ligne17$ = " 2 - 0,2     11,537" + chr(248) + "   0,98    ":      Locate 17, 70: Print ligne17$
ligne18$ = " 3 - 0,3     17,458" + chr(248) + "   0,954   ":      Locate 18, 70: Print ligne18$
ligne19$ = " 4 - 0,4     23,578" + chr(248) + "   0,917   ":      Locate 19, 70: Print ligne19$
ligne20$ = " 5 - 0,5     30"     + chr(248) + "       0,866   ":  Locate 20, 70: Print ligne20$
ligne21$ = " 6 - 0,6     36,87"  + chr(248) + "    0,8     ":     Locate 21, 70: Print ligne21$
ligne22$ = " 7 - 0,707   45"     + chr(248) + "       0,7071  ":  Locate 22, 70: Print ligne22$
ligne23$ = " 8 - 0,8     53,13"  + chr(248) + "    0,6     ":     Locate 23, 70: Print ligne23$
ligne24$ = " 9 - 0,866   60"     + chr(248) + "       0,5     ":  Locate 24, 70: Print ligne24$
ligne26$ =  " C - Ondes convergentes.       ": Locate 26, 70: Print ligne26$
ligne27$ =  " D - Ondes divergentes.        ": Locate 27, 70: Print ligne27$
ligne28$ =  " S - Ondes stationnaires.      ": Locate 28, 70: Print ligne28$
ligne29$ =  " Longueur d'onde: cliquer.     "
ligne35$ =  "    I - Initialiser.    ": Locate 35, 39: Print ligne35$
ligne36$ =  "    Quitter (Echap).    ": Locate 36, 39: Print ligne36$
ligne37$ =  "                        "
Gosub flecheGauche: Gosub flecheDroite
Locate 31, 71: Print "Bta....... "; chr(225); " = sin "; chr(233); " = v / c"
Locate 32, 71: Print "Thta...... "; chr(233); " = arc sin "; chr(225)
Locate 33, 71: Print "Contraction g = cos "; chr(233)
Color blanc, rouge
Locate 27, 9: Print " LES TRANSFORMATIONS DE LORENTZ ET L'EFFET DOPPLER."
Line(63, 415)-(471, 415), rouge, b
Line(63, 413)-(473, 432), noir, b
Line(64, 414)-(472, 431), blanc, b
Color vert, fond
Locate 35, 63: Print "9 juin 2006. Ce programme peut tre"
Locate 36, 63: Print "distribu, copi ou modifi librement.";
Locate 37, 63: Print "Gabriel LaFrenire.  glafreniere.com";
Color noir, fond
Locate 29, 2: Print "Ce programme dmontre que les transformations de Lorentz ne sont"
Locate 30, 2: Print "rien d'autre et rien de plus que le reflet de l'effet Doppler que"
Locate 31, 2: Print "subit la matire. S'il est vrai que les lectrons assemblent les"
Locate 32, 2: Print "molcules en fonction de leur longueur d'onde, la matire en mou-"
Locate 33, 2: Print "vement doit voluer  une cadence plus lente et se contracter"
Locate 34, 2: Print "comme le prvoyait Lorentz, soit selon:"
Color noir, blanc
Line(50,555)-(300,595), blanc, bf
Line(50,555)-(300,595), noir, b
Locate 36, 10: Print "x' = x * Cos "; chr(233); " + t * Sin "; chr(233)
Locate 37, 10: Print "t' = t * Cos "; chr(233); " - x * Sin "; chr(233);
Color noir, fond
Gosub MiseAJour
Return

'-------------------------------- MISE  JOUR DES DONNES ------------------------------------
MiseAJour:
Screenset 2
Color noir, fond
Locate 15, 70: Print ligne15$
Locate 16, 70: Print ligne16$
Locate 17, 70: Print ligne17$
Locate 18, 70: Print ligne18$
Locate 19, 70: Print ligne19$
Locate 20, 70: Print ligne20$
Locate 21, 70: Print ligne21$
Locate 22, 70: Print ligne22$
Locate 23, 70: Print ligne23$
Locate 24, 70: Print ligne24$
Locate 26, 70: Print ligne26$
Locate 27, 70: Print ligne27$
Locate 28, 70: Print ligne28$
Locate 29, 70: Print " Longueur d'onde:"; lambda; " pixels. "
Color bleu, fond
beta = Val(vitesse$)                                      'exceptions pour 0,707 et 0,866.
Select Case vitesse$                                      'indiquer la vitesse en cours.
  Case "0":    Locate 15, 70: Print ligne15$
  Case ".1":   Locate 16, 70: Print ligne16$
  Case ".2":   Locate 17, 70: Print ligne17$
  Case ".3":   Locate 18, 70: Print ligne18$
  Case ".4":   Locate 19, 70: Print ligne19$
  Case ".5":   Locate 20, 70: Print ligne20$
  Case ".6":   Locate 21, 70: Print ligne21$
  Case ".707": Locate 22, 70: Print ligne22$
               beta = Sin(pi / 4)
  Case ".8":   Locate 23, 70: Print ligne23$
  Case ".866": Locate 24, 70: Print ligne24$
               beta = Sin(pi / 3)
End Select
Select Case mode$
  Case "convergentes":  Locate 26, 70: Print ligne26$
  Case "divergentes":   Locate 27, 70: Print ligne27$
  Case "stationnaires": Locate 28, 70: Print ligne28$
End Select
Color noir, fond
theta = Asin(beta)                                        'inclinaison des ondes transversales.
image = 0
Screenset page1, page2
Return
